image: registry.gitlab.com/piotr.rozyczko/icet

variables:
  INSTDIR_WINDOWS: "local_installation_windows"

stages:
    - build
    - test
#------------------- build stage -------------------

.build:
  stage: build

build:windows:
  before_script:
    - $env:PATH+=";C:\Python38;C:\Python38\Scripts"
    - $env:PYTHONPATH+="$PWD/${INSTDIR_WINDOWS}"
    - Set-Alias -Name pip3 -Value pip
  extends: .build
  script:
    - pip3 install --target=$INSTDIR_WINDOWS .
  artifacts:
    expire_in: 2 days
    paths:
      - local_installation_windows/
  # only:
  #   - schedules
  tags:
    - win10test

#------------------- test stage -------------------

.basic_tests:
  stage: test
  coverage: '/TOTAL.+ ([0-9]{1,3}%)/'
  script:
    - pip3 install numba
    - pip3 install trainstation
    - xdoctest icet
    - xdoctest mchammer
    - pytest -v -m coverage_hangup tests/
    - coverage run -m pytest --verbose -m "not coverage_hangup" --junitxml=report.xml tests/
    - coverage report -m --omit=icet/tools/constituent_strain_helper_functions.py
    - coverage html --omit=icet/tools/constituent_strain_helper_functions.py

basic_tests:windows:
  before_script:
    - $env:PATH+=";C:\Python38;C:\Python38\Scripts"
    - $env:PYTHONPATH+="$PWD/${INSTDIR_WINDOWS}"
  extends: .basic_tests
  needs:
    - build:windows
  tags:
    - win10test
  #only:
  #  - schedules
  artifacts:
    expire_in: 2 days
    paths:
      - htmlcov/
    reports:
      junit: report.xml

# include:
#   - template: Code-Quality.gitlab-ci.yml

#------------------- deploy stage -------------------

# pages:
#   stage: deploy
#   tags:
#     - linux
#   artifacts:
#     expire_in: 14 days
#     paths:
#       - public
#   only:
#     - master
#     - tags
#   script:
#     - mkdir -p public/dev
#     - mv htmlcov/ public/
#     - export PYTHONPATH=$PWD/$INSTDIR_LINUX:${PYTHONPATH}
#     # --------------------------
#     # DEVELOPMENT VERSION
#     - git checkout master
#     - tag=$(git describe | tail -1)
#     - echo "tag= $tag"
#     - cd doc/apidoc/
#     - doxygen Doxyfile
#     - cd ../..
#     - mv doc/apidoc/html/ public/dev/apidoc/
#     - sed -i "s/version = ''/version = '$tag'/" doc/userguide/conf.py
#     - grep version doc/userguide/conf.py
#     - sphinx-build -W doc/userguide/ public/dev/
#     - cd examples
#     - find tutorial/ -print | zip ../public/dev/tutorial.zip -@
#     - find advanced_topics/ -print | zip ../public/dev/advanced_topics.zip -@
#     - cd ..
#     - find tests/ -print | zip public/dev/tests.zip tests/structure_databases/*.db -@
#     - git checkout -- doc/userguide/conf.py
#     # --------------------------
#     # STABLE VERSION
#     - tag=$(git tag | tail -1)
#     - echo "tag= $tag"
#     - git checkout $tag
#     # We need to re-install because C++ objects are imported when building the documentation 
#     - rm -r $INSTDIR_LINUX
#     - mkdir $INSTDIR_LINUX
#     - pip3 install --target=$INSTDIR_LINUX .
#     - cd doc/apidoc/
#     - doxygen Doxyfile
#     - cd ../..
#     - mv doc/apidoc/html/ public/apidoc/
#     - sed -i "s/version = ''/version = '$tag'/" doc/userguide/conf.py
#     - ORIG_PYTHONPATH=$PYTHONPATH
#     - export PYTHONPATH=$PWD:$PYTHONPATH
#     - sphinx-build -W doc/userguide/ public/
#     - cd examples
#     - find tutorial/ -print | zip ../public/tutorial.zip -@
#     - find advanced_topics/ -print | zip ../public/advanced_topics.zip -@
#     - cd ..
#     - find tests/ -print | zip public/tests.zip tests/structure_databases/*.db -@
#     - export PYTHONPATH=$ORIG_PYTHONPATH
#     # --------------------------
#     - ls -l public/

# pypi:
#   stage: deploy
#   tags:
#     - linux
#   only:
#     - tags
#   when: manual
#   environment:
#       name: pypi-upload
#   script:
#     - export PYTHONPATH=$PWD/$INSTDIR_LINUX:${PYTHONPATH}
#     # check out the latest tag (redundant if job is limited to tags; still a sensible precaution)
#     - tag=$(git tag | tail -1)
#     - echo "tag= $tag"
#     - git checkout $tag
#     # create source distribution and push to PyPI
#     - python3 setup.py sdist
#     - ls -l dist/
#     - python3 -m twine upload dist/*

